#include <vector>

using namespace std;

vector<int> drogi[50000];
bool kolor[50000];
int czas[50000];
int w_kopcu[50000];

struct droga_c {
	int u, v;
	int w, a, t, l;
};

droga_c drogi_bla[1000000];

int heap[50001];
int koniec;

void wtasuj_w_dol (int i);

int pop_heap ()
{
	int res = heap[1];
	heap[1] = heap[koniec--];
	w_kopcu[heap[1]] = 1;
	wtasuj_w_dol (1);
	return res;
}

bool greater (int i, int j)
{
	return czas[heap[i]] > czas[heap[j]];
}

void zamien (int i, int j)
{
	if (i != j) {
		swap (heap[i], heap[j]);
		w_kopcu[heap[i]] = i;
		w_kopcu[heap[j]] = j;
	}
}

void wtasuj_w_dol (int i)
{
	int j = i;
	if (2 * i <= koniec && greater (j, 2 * i)) {
		j = 2 * i;
	}
	if (2 * i + 1 <= koniec && greater (j, 2 * i + 1)) {
		j = 2 * i + 1;
	}
	zamien (i, j);
	if (i != j) wtasuj_w_dol (j);
}

void push_heap (int p)
{
	int i = ++koniec;
	heap[koniec] = p;
	while (i > 1 && greater (heap[i / 2], p)) {
		zamien (i, i / 2);
		i = i / 2;
	}
}

void relax (int i)
{
	while (i > 1 && greater (heap[i / 2], heap[i])) {
		zamien (i, i / 2);
		i = i / 2;
	}
}

int czekaj (int czas, int droga)
{
	droga_c& t = drogi_bla[droga];
	if (t.t == 0) return 0;
	int tmp = ((czas - t.a) % t.t);
	if (tmp < 0) tmp = t.t + tmp;
	if (tmp < t.l) return 0; else return t.t - tmp;
}

int main ()
{
	int d;
	scanf ("%d", &d);

	for (int di = 0; di < d; ++di) {
		for (int i = 0; i < 50000; ++i) {
			drogi[i].clear ();
			kolor[i] = false;
			koniec = 0;
		}
		int n, m;
		scanf ("%d %d", &n, &m);

		for (int i = 0; i < m; ++i) {
			int u, v, w, t, a, l;
			scanf ("%d %d %d %d %d %d", &u, &v, &w, &t, &a, &l);
			--u; --v;
			drogi[u].push_back (i);
			drogi_bla[i].u = u;
			drogi_bla[i].v = v;
			drogi_bla[i].w = w;
			drogi_bla[i].t = t;
			drogi_bla[i].a = a;
			drogi_bla[i].l = l;
		}

		czas[0] = 0;
		push_heap (0); // baza 0 z czasem 0
		while (true) {
			if (koniec == 0) {
				printf ("NIE\n");
				break;
			}
			int x = pop_heap ();
			if (x == n - 1) {
				printf ("%d\n", czas[n - 1]);
				break;
			}
			for (vector<int>::const_iterator i = drogi[x].begin (); i != drogi[x].end (); ++i) {
				int v = drogi_bla[*i].v;
				int w = drogi_bla[*i].w;
				if (kolor[v] && czas[v] > czas[x] + w + czekaj (czas[x], *i)) {
					czas[v] = czas[x] + w + czekaj (czas[x], *i);
					relax (w_kopcu[v]);
				} else {
					czas[v] = czas[x] + w + czekaj (czas[x], *i);
					push_heap (v);
					kolor[v] = true;
				}
			}
		}
	}

	return 0;
}
